// Import the modules we need
var express = require ('express')
var session = require ('express-session');
var ejs = require('ejs')
var bodyParser= require ('body-parser')
const mysql = require('mysql');
var validator = require ('express-validator');
const expressSanitizer = require('express-sanitizer');



// Create the express application object

const app = express();
const port = 8000;
app.use(expressSanitizer());
app.use(bodyParser.urlencoded({ extended: true }));


// Create a session
app.use(session({
    secret: 'somerandomstuff',
    resave: false,
    saveUninitialized: false,
    cookie: {
    expires: 600000
    }
}));

// Set up css
app.use('/public', express.static(__dirname + "/public"));

app.use(express.static(__dirname + "/public"));

app.use(express.static(__dirname + "/js"));



// Define the database connection
const db = mysql.createConnection ({
    host: 'localhost',
    user: 'c',
    password: 'c',
    database: 'store'
});

// Connect to the database
db.connect((err) => {
    if (err) {
        throw err;
    }
    console.log('Connected to database');
});
global.db = db;


// Express will pick up HTML files in said directory 
// __dirname will get the current directory
app.set('views', __dirname + '/views');


// EJS as the templating engine
app.set('view engine', 'ejs');

// Express processes html files
// EJS's rendering engine
app.engine('html', ejs.renderFile);

// Define our data
var shopData = {shopName: "Re-Turn"}

// Requires the main.js file inside the routes folder passing in the Express app and data as arguments.  All the routes will go in this file
require("./routes/main")(app, shopData);

// Start the web app listening
app.listen(port, () => console.log(`Example app listening on port ${port}!`))